#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stream.h>
#include <sys/tihdr.h>
#include <sys/timod.h>
#include <fcntl.h>
#include <stropts.h>
#include <poll.h>
#include <tiuser.h>
#include <errno.h>
#include <netinet/in.h>


main(argc, argv)
	int argc;
	char *argv[];
{
	char *timod = "timod";
	int d, i, j, flags;
	struct strioctl si;
	union {
		long type;
		struct T_info_req tr;
		struct T_info_ack ti;
		struct T_bind_req br;
		struct T_conn_req cr;
		struct T_error_ack err;
		struct T_ok_ack ok;
		struct T_discon_ind dis;
		char data[1024];
	} buf;
	struct sockaddr_in *sa;
	struct strbuf ctl, dat;

	d = open(argv[1], O_RDWR);
	printf("d = %d, errno = %d\n", d, errno);
	if (!(i = ioctl(d, I_FIND, timod))) {
		printf("i = %d, timod = %d, errno = %d\n", i, timod, errno);
		i = ioctl(d, I_PUSH, timod);
		printf("i = %d, timod = %d, errno = %d\n", i, timod, errno);
	}

	buf.tr.PRIM_type = T_INFO_REQ;
	si.ic_cmd = TI_GETINFO;
	si.ic_timout = 5;
	si.ic_len = sizeof(struct T_info_req);
	si.ic_dp = &buf;
	i = ioctl(d, I_STR, &si);
	printf("T_INFO_REQ: i = %d, errno = %d\n", i, errno);

	printf("length = %d\n", si.ic_len);
	printf("PRIM_type = %d\n", buf.ti.PRIM_type);
	printf("TSDU_size = %d\n", buf.ti.TSDU_size);
	printf("ETSDU_size = %d\n", buf.ti.ETSDU_size);
	printf("CDATA_size = %d\n", buf.ti.CDATA_size);
	printf("DDATA_size = %d\n", buf.ti.DDATA_size);
	printf("ADDR_size = %d\n", buf.ti.ADDR_size);
	printf("OPT_size = %d\n", buf.ti.OPT_size);
	printf("TIDU_size = %d\n", buf.ti.TIDU_size);
	printf("SERV_type = %d\n", buf.ti.SERV_type);
	printf("CURRENT_state = %d\n", buf.ti.CURRENT_state);

	buf.br.PRIM_type = T_BIND_REQ;
	buf.br.ADDR_length = buf.br.ADDR_offset = 0;
	buf.br.CONIND_number = 0;
	si.ic_cmd = TI_BIND;
	si.ic_timout = 5;
	si.ic_len = sizeof(struct T_bind_req);
	si.ic_dp = &buf;
	i = ioctl(d, I_STR, &si);
	printf("T_BIND_REQ: i = %d, errno = %d\n", i, errno);
	printf("            prim = %d\n", buf.type);
	switch (buf.cr.PRIM_type) {
		case T_DISCON_IND:
			printf("        discon: reason=%d, seq=%d\n",
				buf.dis.DISCON_reason,
				buf.dis.SEQ_number);
			break;

		case T_ERROR_ACK:
			printf("        error: prim=%d, TLI=%d, UNIX=%d\n",
				buf.err.ERROR_prim, buf.err.TLI_error,
				buf.err.UNIX_error);
			break;

		case T_OK_ACK:
			printf("        ok: prim=%d\n",
				buf.ok.CORRECT_prim);
			break;
	}
	sleep(1);

	buf.tr.PRIM_type = T_INFO_REQ;
	si.ic_cmd = TI_GETINFO;
	si.ic_timout = 5;
	si.ic_len = sizeof(struct T_info_req);
	si.ic_dp = &buf;
	i = ioctl(d, I_STR, &si);
	printf("T_INFO_REQ: i = %d, errno = %d\n", i, errno);

	printf("length = %d\n", si.ic_len);
	printf("PRIM_type = %d\n", buf.ti.PRIM_type);
	printf("TSDU_size = %d\n", buf.ti.TSDU_size);
	printf("ETSDU_size = %d\n", buf.ti.ETSDU_size);
	printf("CDATA_size = %d\n", buf.ti.CDATA_size);
	printf("DDATA_size = %d\n", buf.ti.DDATA_size);
	printf("ADDR_size = %d\n", buf.ti.ADDR_size);
	printf("OPT_size = %d\n", buf.ti.OPT_size);
	printf("TIDU_size = %d\n", buf.ti.TIDU_size);
	printf("SERV_type = %d\n", buf.ti.SERV_type);
	printf("CURRENT_state = %d\n", buf.ti.CURRENT_state);

	buf.cr.PRIM_type = T_CONN_REQ;
	buf.cr.OPT_length = buf.cr.OPT_offset = 0;
	buf.cr.DEST_length = sizeof(struct sockaddr);
	buf.cr.DEST_offset = sizeof(buf.cr);
	sa = (char *)&buf + buf.cr.DEST_offset;
	sa->sin_family = AF_INET;
	sa->sin_port = htons(7);
	sa->sin_addr.s_addr = htonl(0x7f000001);
	ctl.buf = &buf;
	ctl.len = sizeof(buf.cr) + sizeof(struct sockaddr);
	ctl.maxlen = sizeof(buf);
flags = fcntl(d, F_GETFL, 0);
fcntl(d, F_SETFL, flags | O_NDELAY);
	i = putmsg(d, &ctl, (void *)0, 0);
	printf("T_CONN_REQ: i = %d, errno = %d\n", i, errno);
#if 0
fcntl(d, F_SETFL, flags);
#endif

	for (j=0; j<3; j++) {
#if 1
		struct pollfd rfd;

		rfd.fd = d;
		rfd.events = (j == 0 ? POLLPRI : POLLIN);
		printf("poll: ...\n");
		i = poll(&rfd, 1, -1);
		printf("poll: i = %d, errno = %d\n", i, errno);
#endif
		ctl.maxlen = sizeof(buf);
		ctl.buf = &buf;
		dat.maxlen = -1;
		dat.len = dat.buf = 0;
		flags = 0;
		i = getmsg(d, &ctl, &dat, &flags);
		printf("getmsg: i = %d, len = %d, errno = %d\n", i, ctl.len, errno);
		printf("        prim = %d\n", buf.cr.PRIM_type);
		switch (buf.cr.PRIM_type) {
			case T_DISCON_IND:
				printf("        discon: reason=%d, seq=%d\n",
					buf.dis.DISCON_reason,
					buf.dis.SEQ_number);
				break;

			case T_ERROR_ACK:
				printf("        error: prim=%d, TLI=%d, UNIX=%d\n",
					buf.err.ERROR_prim, buf.err.TLI_error,
					buf.err.UNIX_error);
				break;

			case T_OK_ACK:
				printf("        ok: prim=%d\n",
					buf.ok.CORRECT_prim);
				break;
		}
		sleep(1);
	}
}
