#include <sys/types.h>
#include <sys/stream.h>
#include <sys/tihdr.h>
#include <sys/timod.h>
#include <fcntl.h>
#include <stropts.h>
#include <tiuser.h>
#include <errno.h>


main(argc, argv)
	int argc;
	char *argv[];
{
	char *timod = "timod";
	int d, i;
	struct strioctl si;
	union {
		struct T_info_req tr;
		struct T_info_ack ti;
	} buf;

	d = open(argv[1], O_RDWR);
	printf("d = %d, errno = %d\n", d, errno);
	if (!(i = ioctl(d, I_FIND, timod))) {
		printf("i = %d, timod = %d, errno = %d\n", i, timod, errno);
		i = ioctl(d, I_PUSH, timod);
		printf("i = %d, timod = %d, errno = %d\n", i, timod, errno);
	}

	buf.tr.PRIM_type = T_INFO_REQ;
	si.ic_cmd = TI_GETINFO;
	si.ic_timout = 5;
	si.ic_len = sizeof(struct T_info_req);
	si.ic_dp = &buf;
	i = ioctl(d, I_STR, &si);
	printf("i = %d, errno = %d\n", i, errno);

	printf("length = %d\n", si.ic_len);
	printf("PRIM_type = %d\n", buf.ti.PRIM_type);
	printf("TSDU_size = %d\n", buf.ti.TSDU_size);
	printf("ETSDU_size = %d\n", buf.ti.ETSDU_size);
	printf("CDATA_size = %d\n", buf.ti.CDATA_size);
	printf("DDATA_size = %d\n", buf.ti.DDATA_size);
	printf("ADDR_size = %d\n", buf.ti.ADDR_size);
	printf("OPT_size = %d\n", buf.ti.OPT_size);
	printf("TIDU_size = %d\n", buf.ti.TIDU_size);
	printf("SERV_type = %d\n", buf.ti.SERV_type);
	printf("CURRENT_state = %d\n", buf.ti.CURRENT_state);
}
