#include <sys/types.h>
#include <sys/socket.h>
#include <sys/netinet/in.h>
#include <sys/stream.h>
#include <sys/tihdr.h>
#include <sys/tiuser.h>
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <stropts.h>
#include <poll.h>


extern int t_errno;


main(argc, argv)
	int argc;
	char *argv[];
{
	struct t_info info;
	struct t_call *call;
	int d, i, flags;
	char buf[1024];

	d = t_open("/dev/inet/tcp", O_RDWR, &info);
	fprintf(stderr, "t_open returned %d, t_errno = %d, errno = %d\n",
		d, t_errno, errno);
	if (d < 0) t_error("t_open");

	fprintf(stderr, "addr: %d\n", info.addr);
	fprintf(stderr, "options: %d\n", info.options);
	fprintf(stderr, "tsdu: %d\n", info.tsdu);
	fprintf(stderr, "etsdu: %d\n", info.etsdu);
	fprintf(stderr, "connect: %d\n", info.connect);
	fprintf(stderr, "discon: %d\n", info.discon);
	fprintf(stderr, "servtype: %d\n", info.servtype);

#if 0
	/* Unbound, unconnected. This should give an error. */
	i = t_snd(d, "should error", 12, 0);
	fprintf(stderr, "t_snd returned %d, t_errno = %d, errno = %d\n",
		i, t_errno, errno);
	if (i < 0) t_error("t_snd");
#endif
#if 0
{
struct strbuf ctl, dat;
struct T_data_req req;
int i, j, flags;
union {
	struct T_info_req tr;
	struct T_info_ack ti;
	struct T_bind_req br;
	struct T_conn_req cr;
	struct T_error_ack err;
	struct T_ok_ack ok;
	char data[1024];
} buf;
req.PRIM_type = T_DATA_REQ;
req.MORE_flag = 0;
ctl.len = sizeof(req);
ctl.buf = (char *)&req;
dat.len = 4;
dat.buf = "test";
errno = t_errno = 0;
i = putmsg(d, &ctl, &dat, 0);
printf("T_DATA_REQ: i = %d, errno = %d\n", i, errno);
for (j=0; j<2; j++) {
	ctl.maxlen = sizeof(buf);
	ctl.buf = (char *)&buf;
	dat.maxlen = -1;
	dat.len = 0;
	dat.buf = NULL;
	flags = 0;
	errno = t_errno = 0;
	i = getmsg(d, &ctl, &dat, &flags);
	printf("getmsg: i = %d, len = %d, errno = %d, t_errno = %d\n",
		i, ctl.len, errno);
	printf("        prim = %d\n", buf.cr.PRIM_type);
	switch (buf.cr.PRIM_type) {
		case T_ERROR_ACK:
			printf("        error: prim=%d, TLI=%d, UNIX=%d\n",
				buf.err.ERROR_prim, buf.err.TLI_error,
				buf.err.UNIX_error);
			break;

		case T_OK_ACK:
			printf("        ok: prim=%d\n",
				buf.ok.CORRECT_prim);
			break;
	}
	sleep(1);
}
}
#endif

	i = t_bind(d, NULL, NULL);
	fprintf(stderr, "t_bind returned %d, t_errno = %d, errno = %d\n",
		i, t_errno, errno);
	if (i < 0) t_error("t_bind");

	call = (struct t_call *)t_alloc(d, T_CALL, T_ALL);
	fprintf(stderr, "call = 0x%08lx\n", call);
	fprintf(stderr, "call->addr.buf = 0x%08lx, maxlen = %d\n",
		call->addr.buf, call->addr.maxlen);
	fprintf(stderr, "call->opt.buf = 0x%08lx, maxlen = %d\n",
		call->opt.buf, call->opt.maxlen);
	fprintf(stderr, "call->udata.buf = 0x%08lx, maxlen = %d\n",
		call->udata.buf, call->udata.maxlen);
	call->opt.len = call->udata.len = 0;
	call->addr.len = sizeof(struct sockaddr_in);
	((struct sockaddr_in *)(call->addr.buf))->sin_family = AF_INET;
	((struct sockaddr_in *)(call->addr.buf))->sin_port = htons(7);
	((struct sockaddr_in *)(call->addr.buf))->sin_addr.s_addr = htonl(0x7f000001);
#if 1
	flags = fcntl(d, F_GETFL, 0);
	fcntl(d, F_SETFL, flags | O_NDELAY);
#endif
	i = t_connect(d, call, NULL);
	fprintf(stderr, "t_connect returned %d, t_errno = %d, errno = %d\n",
		i, t_errno, errno);
	if (i < 0) t_error("t_connect");
#if 1
	fcntl(d, F_SETFL, flags);
#endif

#if 0
	i = t_look(d);
	fprintf(stderr, "t_look returned %d, t_errno = %d, errno = %d\n",
		i, t_errno, errno);
	if (i < 0) t_error("t_look");
{
	struct t_discon dis;
	i = t_rcvdis(d, &dis);
	fprintf(stderr, "t_rcvdis returned %d, t_errno = %d, errno = %d\n",
		i, t_errno, errno);
	fprintf(stderr, "         reason %d, sequence = %d\n",
		i, dis.reason, dis.sequence);
	if (i < 0) t_error("t_rcvdis");
}
#endif
#if 1
{
struct strbuf ctl, dat;
int i, j, flags;
union {
	struct T_info_req tr;
	struct T_info_ack ti;
	struct T_bind_req br;
	struct T_conn_req cr;
	struct T_error_ack err;
	struct T_ok_ack ok;
	char data[1024];
} buf;
for (j=0; j<1; j++) {
	ctl.maxlen = sizeof(buf);
	ctl.buf = (char *)&buf;
	dat.maxlen = -1;
	dat.len = 0;
	dat.buf = NULL;
	flags = 0;
	errno = t_errno = 0;
	i = getmsg(d, &ctl, &dat, &flags);
	printf("getmsg: i = %d, len = %d, errno = %d, t_errno = %d\n",
		i, ctl.len, errno);
	printf("        prim = %d\n", buf.cr.PRIM_type);
	switch (buf.cr.PRIM_type) {
		case T_ERROR_ACK:
			printf("        error: prim=%d, TLI=%d, UNIX=%d\n",
				buf.err.ERROR_prim, buf.err.TLI_error,
				buf.err.UNIX_error);
			break;

		case T_OK_ACK:
			printf("        ok: prim=%d\n",
				buf.ok.CORRECT_prim);
			break;
	}
	sleep(1);
}
}
#endif

	i = t_snd(d, "hello", 5, 0);
	fprintf(stderr, "t_snd returned %d, t_errno = %d, errno = %d\n",
		i, t_errno, errno);
	if (i < 0) t_error("t_snd");

	flags = 0;
	i = t_rcv(d, buf, sizeof(buf)-1, &flags);
	fprintf(stderr, "t_rcv returned %d, t_errno = %d, errno = %d\n",
		i, t_errno, errno);
	if (i < 0)
		t_error("t_rcv");
	else if (i > 0) {
		buf[i] = '\0';
		fprintf(stderr, "t_rcv: flags=0x%x, \"%s\"\n", flags, buf);
	}

	exit(0);
}
