#include <sys/types.h>
#include <sys/socket.h>
#include <sys/netinet/in.h>
#include <sys/tiuser.h>
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>


extern int t_errno;


main(argc, argv)
	int argc;
	char *argv[];
{
	struct t_info info;
	struct t_unitdata *udata;
	struct sockaddr_in addr;
	int d, i, flags;
	char buf[1024];

	d = t_open(argv[1], O_RDWR, &info);
	fprintf(stderr, "t_open returned %d, t_errno = %d, errno = %d\n",
		d, t_errno, errno);

	fprintf(stderr, "addr: %d\n", info.addr);
	fprintf(stderr, "options: %d\n", info.options);
	fprintf(stderr, "tsdu: %d\n", info.tsdu);
	fprintf(stderr, "etsdu: %d\n", info.etsdu);
	fprintf(stderr, "connect: %d\n", info.connect);
	fprintf(stderr, "discon: %d\n", info.discon);
	fprintf(stderr, "servtype: %d\n", info.servtype);

	i = t_bind(d, NULL, NULL);
	fprintf(stderr, "t_bind returned %d, t_errno = %d, errno = %d\n",
		i, t_errno, errno);

#if 0
	/* Bound but not connected. This should give an error. */
	i = t_snd(d, "should error", 12, 0);
	fprintf(stderr, "t_snd returned %d, t_errno = %d, errno = %d\n",
		i, t_errno, errno);
#endif

	udata = (struct t_unitdata *)t_alloc(d, T_UNITDATA, T_ALL);
	udata->opt.len = 0;
	udata->addr.len = sizeof(struct sockaddr_in);
	((struct sockaddr_in *)(udata->addr.buf))->sin_family = AF_INET;
	((struct sockaddr_in *)(udata->addr.buf))->sin_port = htons(7);
	((struct sockaddr_in *)(udata->addr.buf))->sin_addr.s_addr = htonl(0x7f000001);

	udata->udata.len = 5;
	strcpy(udata->udata.buf, "hello");
	i = t_sndudata(d, udata);
	fprintf(stderr, "t_sndudata returned %d, t_errno = %d, errno = %d\n",
		i, t_errno, errno);

	flags = 0;
	i = t_rcvudata(d, udata, &flags);
	fprintf(stderr, "t_rcvudata returned %d, t_errno = %d, errno = %d\n",
		i, t_errno, errno);
	if (i == 0) {
		udata->udata.buf[udata->udata.len] = '\0';
		fprintf(stderr, "t_rcvudata: flags=0x%x, \"%s\"\n",
			flags, udata->udata.buf);
	}

	exit(0);
}
