#include <sys/types.h>
#ifdef __linux__
#include <sys/vfs.h>
#else
#include <sys/statfs.h>
#endif
#include <stdio.h>


main(int argc, char *argv[])
{
	struct statfs st;

#ifdef __linux__
	if (statfs(argv[1], &st)) {
#else
	if (statfs(argv[1], &st, sizeof(struct statfs), 0)) {
#endif
		perror("statfs");
		exit(1);
	}

	printf("FS type:      0x%04x\n", st.f_type);
	printf("Block size:   %ld\n", st.f_bsize);
#ifndef __linux__
	printf("Frag size:    %ld\n", st.f_frsize);
#endif
	printf("Total blocks: %ld\n", st.f_blocks);
	printf("Free blocks:  %ld\n", st.f_bfree);
	printf("Total files:  %ld\n", st.f_files);
	printf("Free files:   %ld\n", st.f_ffree);
#ifndef __linux__
	printf("Vol name:     \"%s\"\n", st.f_fname);
	printf("Pack name:    \"%s\"\n", st.f_fpack);
#endif

	exit(0);
}
