#include <linux/config.h>

#include <linux/module.h>
#include <linux/version.h>

#include <asm/uaccess.h>

#include <linux/a.out.h>
#include <linux/malloc.h>
#include <linux/sched.h>
#include <linux/user.h>

#include <asm/pgtable.h>


#if LINUX_VERSION_CODE < KERNEL_VERSION(2,2,13)
#  define strnlen_user(str, n) strlen_user(str)
#endif


unsigned long *
create_ibcs_tables(struct linux_binprm *bprm, int ibcs)
{
	char *p = (char *)bprm->p;
	unsigned long *argv,*envp;
	unsigned long * sp;
	int argc = bprm->argc;
	int envc = bprm->envc;
	long len;

	sp = (unsigned long *) ((-(unsigned long)sizeof(char *)) & (unsigned long) p);
	sp -= envc+1;
	envp = sp;
	sp -= argc+1;
	argv = sp;
	if (!ibcs) {
		sp--;
		put_user(envp, sp);
		sp--;
		put_user(argv, sp);
	}
	sp--;
	put_user(argc, sp);
	current->mm->arg_start = (unsigned long) p;
	while (argc-->0) {
		put_user(p, argv); argv++;
		len = strnlen_user(p, PAGE_SIZE*MAX_ARG_PAGES);
		/* "can't happen" */
		if (!len || len > PAGE_SIZE*MAX_ARG_PAGES)
			return NULL;
		p += len;
	}
	put_user(NULL,argv);
	current->mm->arg_end = current->mm->env_start = (unsigned long) p;
	while (envc-->0) {
		put_user(p, envp); envp++;
		len = strnlen_user(p, PAGE_SIZE*MAX_ARG_PAGES);
		/* "can't happen" */
		if (!len || len > PAGE_SIZE*MAX_ARG_PAGES)
			return NULL;
		p += len;
	}
	put_user(NULL,envp);
	current->mm->env_end = (unsigned long) p;
	bprm->p = (unsigned long)sp;
	return sp;
}
